/* Generated by powerful Codeforces Tool
 * Author: xxxodarap
 * Time: 2023-08-08 00:28
**/

#include<bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef double lf;
typedef complex<lf> cp;

const lf EPSI = 1e-12;

// ========== Helper functions ==========
lf dot ( cp a , cp b) { return ( conj (a) * b).real () ; }
lf cross ( cp a , cp b) { return ( conj (a) * b).imag () ; }
bool is_upper(const cp &c)
{ return imag(c) > 0 or (imag(c) == 0 and real(c) >= 0); }
bool cmp_ang(const cp &l, const cp &r)
{ return is_upper(l) == is_upper(r) ? cross(l, r) > 0 : is_upper(l); } // doing this complex logic, because arg (atan2) is slow
                                                                       //
bool cmp_bottomleft(const cp &l, const cp &r) {
  return pair(imag(l), real(l)) < pair(imag(r), real(r));
}

// ========== NEW Version ==========
vector<cp> minkowski2(vector<cp> &P, vector<cp> &Q){
    rotate(begin(P), min_element(begin(P), end(P), cmp_bottomleft), end(P));
    rotate(begin(Q), min_element(begin(Q), end(Q), cmp_bottomleft), end(Q));
    vector<cp> res; res.reserve(size(P) + size(Q));
    // we must ensure cyclic indexing
    P.insert(end(P), {P[0], P[1]});
    Q.insert(end(Q), {Q[0], Q[1]});
    // main part
    size_t i = 0, j = 0;
    while(i < P.size() - 2 || j < Q.size() - 2){
        res.emplace_back(P[i] + Q[j]);
        auto cro = cross(P[i + 1] - P[i], Q[j + 1] - Q[j]);
        if(cro >= 0 && i < P.size() - 2) ++i;
        if(cro <= 0 && j < Q.size() - 2) ++j;
    }
    return res;
}

// ========== other approaches ==========
vector<cp> minkowski_many(vector<vector<cp>> &polygons){
    if(size(polygons) < 1) return vector<cp>();
    cp pos = {0,0};
    vector<cp> dirs;
    for(auto poly: polygons){
        pos += *min_element(begin(poly), end(poly), cmp_bottomleft);
        vector<cp> ds;
        adjacent_difference(begin(poly), end(poly), back_inserter(ds));
        ds[0] = poly[0] - end(poly)[-1];
        dirs.insert(end(dirs), begin(ds), end(ds));
    }
    sort(begin(dirs), end(dirs), cmp_ang);
    dirs.push_back(dirs[0]);
    vector<cp> res {pos};
    for(int i = 0; i < size(dirs) - 1; i++){
        auto d = dirs[i];
        while(cross(d, dirs[i+1]) < EPSI and dot(d, dirs[i+1]) > 0)
            pos += dirs[i+1], i++;
        res.emplace_back(pos += d);
    }
    return res;
}

vector<cp> minkowski2_alt(vector<cp> &a, vector<cp> &b){
    auto ait = min_element(cbegin(a), cend(a), cmp_bottomleft);
    auto bit = min_element(cbegin(b), cend(b), cmp_bottomleft);
    vector<cp> ad, bd, res;
    adjacent_difference(cbegin(a), cend(a), back_inserter(ad));
    adjacent_difference(cbegin(b), cend(b), back_inserter(bd));
    ad[0] = a[0] - end(a)[-1], bd[0] = b[0] - end(b)[-1];
    rotate(begin(ad), min_element(begin(ad), end(ad), cmp_ang), end(ad));
    rotate(begin(bd), min_element(begin(bd), end(bd), cmp_ang), end(bd));
    merge(begin(ad), end(ad), begin(bd), end(bd), back_inserter(res), cmp_ang);
    exclusive_scan(cbegin(res), cend(res), begin(res), *ait + *bit);
    return res;
}

// ========== main ==========
ll N;
queue<vector<cp>> q;
void solve2() {
    cin >> N;
    cp zero {0,0}, x;
    long long a, b, c ,d;
    for(int i = 0; i < N; i++) {
        cin >> a >> b >> c >> d;
        x = {a-b, c-d};
        q.push({zero, x});
    }

    while (size(q) >= 2) {
        vector<cp> a = q.front(); q.pop();
        vector<cp> b = q.front(); q.pop();
        q.emplace(minkowski2(a, b));
        /* q.emplace(minkowski2_alt(a, b)); // not correct ! */
    }

    lf ans = 0;
    for(auto e: q.front())
        ans = max(ans, norm(e));
    cout << ans << endl;
}

vector<vector<cp>> v;
void solveall(){
    cin >> N;
    cp zero {0,0}, x;
    long long a, b, c ,d;
    for(int i = 0; i < N; i++) {
        cin >> a >> b >> c >> d;
        x = {a-b, c-d};
        if(abs(x) < EPSI) continue;
        v.push_back({zero, x});
    }
    auto res = minkowski_many(v);

    lf ans = 0;
    for(auto e: res)
        ans = max(ans, norm(e));
    cout << ans << endl;
}
 
vector<vector<cp>> w;
void test(){
    vector<cp> a = {{-4, 2}, {-3, 1}, {-2, 2}},
        b = {{2,1}, {4,1}, {4,3}, {2, 3}};
    w = {a,b};
    auto c = minkowski_many(w);

    for(auto e: c) cerr << e << " "; cerr << endl;

    auto d = minkowski2(a, b);
    for(auto e: d) cerr << e << " "; cerr << endl;

    cp e {1, 2}, f {-1, -2}, g{2, 4};
    cerr << "direction test" << endl;
    cerr << dot(e,f) << endl;
    cerr << dot(e,g) << endl;
    cerr << dot(f,g) << endl;
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << setprecision(12);

    solve2();
    /* solveall(); */
    /* test(); */
}
